#pragma once
#include <string>
#include "shader.h"
#include "mesh.h"
#include "matrix.h"
using namespace std;


struct VertexData
{
	float p_x, p_y, p_z;
	float c_u, c_v;
};

struct Global
{
	Global();

	bool running;

	vect3f trans;
	matrix3f rot;
	matrix4f mvp; // model/view/projection

	Mesh mesh;
	unsigned int mesh_vb;
	unsigned int mesh_vb_size;

	union
	{
		struct
		{
			unsigned int tex_box;
			unsigned int tex_tent;
			unsigned int tex_lanczos2;
			unsigned int tex_jinc2;
			unsigned int tex_gauss;
			unsigned int tex_rainbow;
		};

		unsigned int textures[5];
	};
	int texture_used;

	ShaderObject shader_hw;
	ShaderObject shader_trilinear;
	ShaderObject shader_sample2_lin_sym_uniform;
	ShaderObject shader_sample3_lin_sym_uniform;
	ShaderObject shader_sample4_lin_sym_uniform;
	ShaderObject shader_sample5_lin_sym_uniform;
	ShaderObject shader_sample6_lin_sym_uniform;
	ShaderObject shader_sample7_lin_sym_uniform;
	ShaderObject shader_sample8_lin_sym_uniform;
	ShaderObject shader_sample9_lin_sym_uniform;
	ShaderObject shader_sample10_lin_sym_uniform;
	ShaderObject shader_feline;
	ShaderObject shader_feline_sample8;
};

extern Global g;
extern const double pi;

string load_file_to_string(string filename);