#include "image_base.h"
#include "freeimageplus.h"

void load_into(Array2D<vect4f> &ret, string fn)
{
	// load it from file
	fipImage img;
	img.load(fn.c_str());
	ret.resize(img.getWidth(), img.getHeight());
	int pix_num = ret.s[0] * ret.s[1];

	// upload the data
	if (img.getBitsPerPixel() == 24)
	{
		for (int j = 0; j < ret.s[1]; j++)
		{
			unsigned char *line = img.getScanLine(j);
			for (int i = 0; i < ret.s[0]; i++)
			{
				int idx = j*ret.s[0] + i;
				ret.data[idx][0] = line[i*3 + 2] / 255.0;
				ret.data[idx][1] = line[i*3 + 1] / 255.0;
				ret.data[idx][2] = line[i*3 + 0] / 255.0;
				ret.data[idx][3] = 1;
			}
		}
	}
	else if (img.getBitsPerPixel() == 32)
	{
		for (int j = 0; j < ret.s[1]; j++)
		{
			unsigned char *line = img.getScanLine(j);
			for (int i = 0; i < ret.s[0]; i++)
			{
				int idx = j*ret.s[0] + i;
				ret.data[idx][0] = line[i*4 + 2] / 255.0;
				ret.data[idx][1] = line[i*4 + 1] / 255.0;
				ret.data[idx][2] = line[i*4 + 0] / 255.0;
				ret.data[idx][3] = line[i*4 + 3] / 255.0;
			}
		}
	}
}

void save_image(string fn, Array2D<vect4f> &in, int bits)
{
	// load it from file
	fipImage img;
	img.load(fn.c_str());
	img.setSize(FIT_BITMAP, in.s[0], in.s[1], bits);

	// upload the data
	if (bits == 24)
	{
		for (int j = 0; j < in.s[1]; j++)
		{
			unsigned char *line = img.getScanLine(j);
			for (int i = 0; i < in.s[0]; i++)
			{
				int idx = j*in.s[0] + i;
				line[i*3 + 2] = in.data[idx][0] * 255.0;
				line[i*3 + 1] = in.data[idx][1] * 255.0;
				line[i*3 + 0] = in.data[idx][2] * 255.0;
			}
		}
	}
	else if (bits == 32)
	{
		for (int j = 0; j < in.s[1]; j++)
		{
			unsigned char *line = img.getScanLine(j);
			for (int i = 0; i < in.s[0]; i++)
			{
				int idx = j*in.s[0] + i;
				line[i*3 + 2] = in.data[idx][0] * 255.0;
				line[i*3 + 1] = in.data[idx][1] * 255.0;
				line[i*3 + 0] = in.data[idx][2] * 255.0;
				line[i*3 + 3] = in.data[idx][3] * 255.0;
			}
		}
	}

	img.save(fn.c_str());
}

