#include "mipsample.h"
#include <math.h>

static void mip_img_jinc4(Array2D<vect4f> &dst, Array2D<vect4f> &src, int miplevel)
{
	int size = 1 << miplevel;

	dst.resize(src.s[0]/size, src.s[1]/size);

	for (int y = 0; y < dst.s[1]; y++)
		for (int x = 0; x < dst.s[0]; x++)
			dst(x,y) = sample_jinc4_ideal(src, (x + .5) / dst.s[0], (y + .5) / dst.s[1], miplevel);
}

void calc_mip_jinc4(MipStack &mip, Array2D<vect4f> &src)
{
	int num_mip_levels = ceil(log(max(src.s[0],src.s[1])-.01)/log(2.0)) + 1;
	mip.img.resize(num_mip_levels);

	mip.s[0] = src.s[0];
	mip.s[1] = src.s[1];

	mip.img[0] = src;

	for (int i = 1; i < num_mip_levels; i++)
		mip_img_jinc4(mip.img[i], src, i);
}
