#include "mipsample.h"
#include <math.h>

static void mip_img_rainbow(Array2D<vect4f> &dst, Array2D<vect4f> &src, int miplevel)
{
	vect4f color;
	color[3] = 1;

	float red[6] =   {0,1,1,0,0,0}; 
	float green[6] = {0,0,0,0,1,1}; 
	float blue[6] =  {0,0,1,1,1,0}; 

	color[0] = red[miplevel%6];
	color[1] = green[miplevel%6];
	color[2] = blue[miplevel%6];

	/*color[0] = .5 + .5*cos(idx * 2.0 * 3.14159 / 10.0);
	color[1] = .5 + .5*cos(idx * 2.0 * 3.14159 / 10.0 + 2.0 * 3.14159 / 3.0);
	color[2] = .5 + .5*cos(idx * 2.0 * 3.14159 / 10.0 + 4.0 * 3.14159 / 3.0);*/

	for (int i = 0; i < 3; i++)
		color[i] = color[i] * color[i];

	int size = 1 << miplevel;

	dst.resize(src.s[0]/size, src.s[1]/size);

	for (int y = 0; y < dst.s[1]; y++)
	{
		for (int x = 0; x < dst.s[0]; x++)
		{
			dst(x,y) = color;
		}
	}
}

void calc_mip_rainbow(MipStack &mip, Array2D<vect4f> &src)
{
	int num_mip_levels = ceil(log(max(src.s[0],src.s[1])-.01)/log(2.0)) + 1;
	mip.img.resize(num_mip_levels);

	mip.s[0] = src.s[0];
	mip.s[1] = src.s[1];

	for (int i = 0; i < num_mip_levels; i++)
		mip_img_rainbow(mip.img[i], src, i);
}
