#pragma once

#include "image_base.h"
#include "array.h"

// how should the edge of an image be treated?
//#define MIP_CLAMP
#define MIP_WRAP

struct MipStack
{
	Array< Array2D<vect4f> > img;

	int s[2];
};

void calc_mip_box(MipStack &mip, Array2D<vect4f> &src);
void calc_mip_tent(MipStack &mip, Array2D<vect4f> &src);
void calc_mip_lanczos2(MipStack &mip, Array2D<vect4f> &src);
void calc_mip_jinc2(MipStack &mip, Array2D<vect4f> &src);
void calc_mip_jinc3(MipStack &mip, Array2D<vect4f> &src);
void calc_mip_jinc4(MipStack &mip, Array2D<vect4f> &src);
void calc_mip_gauss(MipStack &mip, Array2D<vect4f> &src);
void calc_mip_rainbow(MipStack &mip, Array2D<vect4f> &src);

vect4f sample_box_ideal(Array2D<vect4f> &src, float u, float v, float w);
vect4f sample_tent_ideal(Array2D<vect4f> &src, float u, float v, float w);
vect4f sample_lanczos2_ideal(Array2D<vect4f> &src, float u, float v, float w);
vect4f sample_jinc2_ideal(Array2D<vect4f> &src, float u, float v, float w);
vect4f sample_jinc3_ideal(Array2D<vect4f> &src, float u, float v, float w);
vect4f sample_jinc4_ideal(Array2D<vect4f> &src, float u, float v, float w);
vect4f sample_gauss_ideal(Array2D<vect4f> &src, float u, float v, float w);

