#include "screengrabber.h"
#include "GL/glew.h"
#include "FreeImagePlus.h"
#include <direct.h>

void ScreenShot::grab()
{
	int vp[4];
	glGetIntegerv(GL_VIEWPORT, vp);

	w = vp[2];
	h = vp[3];

	data = new unsigned char [w*h*3];

	glFlush();
	glReadPixels(vp[0], vp[1], w, h, GL_RGB, GL_UNSIGNED_BYTE, data);
}

void ScreenShot::save(string fn)
{
	fipImage img;
	img.setSize(FIT_BITMAP, w, h, 24);
	
	for (int i = 0; i < h; i++)
	{
		unsigned char *s = img.getScanLine(i);

		for (int j = 0; j < w; j++)
		{
			s[j*3 + 0] = data[i*w*3 + j*3 + 2];
			s[j*3 + 1] = data[i*w*3 + j*3 + 1];
			s[j*3 + 2] = data[i*w*3 + j*3 + 0];
		}
	}

	img.save(fn.c_str());
}


void MovieGrabber::grabMovieFrame()
{
	ScreenShot *ss = new ScreenShot();
	ss->grab();
	movie.push_back(ss);
}

void MovieGrabber::saveMovieToDir(string dir)
{
	if (dir.size())
	{
		mkdir(dir.c_str());
		if (dir[dir.size()-1] != '/' && dir[dir.size()-1] != '\\')
			dir += '/';
	}

	char *buf = new char [dir.size() + 10];

	for (int i = 0; i < movie.s; i++)
	{
		sprintf(buf, "%s%04d.png", dir.c_str(), i);
		movie[i]->save(buf);
	}

	delete [] buf;
	
	// free memory
	for (int i = 0; i < movie.s; i++)
		delete movie[i];
	movie.clear();
}

