#pragma once

#include "array.h"
#include <string>

using namespace std;

// opengl read pixel wrapper with image saving via freeimage
struct ScreenShot
{
	ScreenShot() { w = h = 0; data = 0; }
	~ScreenShot() { delete [] data; }

	int w, h;
	unsigned char *data;

	void save(string fn);
	void grab();
};

// the idea of the movie grabber is that saving images during an animation may unduely
// slow the animation, but if enough memory is available, we can buffer the movie before saving.
struct MovieGrabber
{
	MovieGrabber(){grabbing = false;}

	Array<ScreenShot*> movie;
	bool grabbing; // does nothing - just for user

	void grabMovieFrame();
	void saveMovieToDir(string dir = "");
};
