#version 410

uniform sampler2D un_tex;
in vec2 ex_coord;
float ex_z;

//int fetches;

vec3 bilinear(vec2 pin, ivec2 size, int lev)
{
	vec2 p, t, f;
	
	for (int i = 0; i < 2; i++)
	{
		p[i] = pin[i] * size[i] - .5;
		f[i] = floor(p[i]);
		t[i] = p[i] - f[i];
	}
	
	float one = 1.0 / size[0];
	
	f += .5;
	f /= size[0];
	
	//fetches += 4;
	return  mix(
			mix(textureLod(un_tex, vec2(f.x,f.y), lev).rgb, textureLod(un_tex, vec2(f.x+one,f.y), lev).rgb, t.x),
			mix(textureLod(un_tex, vec2(f.x,f.y+one), lev).rgb, textureLod(un_tex, vec2(f.x+one,f.y+one), lev).rgb, t.x),
			t.y);
}

vec3 sample_full()
{
	float f = floor(ex_z);
	float t = ex_z - f;
	
	int fi = int(f);
	
	vec3 v0 = bilinear(ex_coord, textureSize(un_tex, fi), fi);
	vec3 v1 = bilinear(ex_coord, textureSize(un_tex, fi+1), fi+1);
	
	return mix(v0, v1, t);
}

void main()
{
	//fetches = 0;
	
	ivec2 ts = textureSize(un_tex, 0);
	int mipmax = int(log2(ts.x));
	
	ex_z = textureQueryLod(un_tex, ex_coord).y;
	
	// sample
	if (ex_z >= mipmax)
	{
		gl_FragColor.rgb = texture(un_tex, ex_coord, ex_z).rgb;
	}
	else if (ex_z <= 0)
	{
		gl_FragColor.rgb = bilinear(ex_coord, ts, 0).rgb;
	}
	else
	{
		gl_FragColor.rgb = sample_full();
	}
	
	//gl_FragColor.rgb = vec3(fetches, fetches, fetches) * 10. / 255.;
}
